#include <linux/module.h>
#include <linux/cdev.h>
#include <linux/kernel.h>
#include <linux/module.h>
#include <linux/init.h>
#include <linux/sched.h>
#include <linux/fs.h>
#include <linux/fcntl.h>
#include <linux/errno.h>

#include <asm/arch/pxa3xx_gpio.h>
#include <asm/arch/zylonite.h>
#include <asm/uaccess.h>

/* Use 'H' as magic number */
#define S1_IOC_MAGIC  'H'
#define	S1_IOCTL_ENABLE_S1	_IOR(S1_IOC_MAGIC, 2, int)
#define	S1_IOCTL_DISENABLE_S1	_IOR(S1_IOC_MAGIC, 3, int)

extern void LCDoff_ready(int ready);

int S1_major = 0;
int S1_minor = 0;
struct cdev *S1_cdev;
int S1_devno;
static const char S1_name[] = "S1_Disable";
int LCDoff_count = 0;

int S1_open(struct inode *inode, struct file *filep)
{
	LCDoff_ready(0);
	return 0;
}
int S1_close(struct inode *inode, struct file *filep)
{
	LCDoff_ready(1);
	return 0;
}
//~ ssize_t S1_read(struct file *filep, char *buf, size_t count,loff_t *f_pos)
//~ {
	//~ //printk("************S1 read************\n");
	//~ return 0;
//~ }
//~ ssize_t S1_write(struct file *filep, const char *buf, size_t count,loff_t *f_pos)
//~ {
	//~ //printk("************S1 write************\n");
	//~ return 0;
//~ }
//~ int S1_ioctl(struct inode *inode, struct file *file, unsigned int cmd,unsigned long arg)
//~ {
	//~ int ret;
	//~ switch (cmd) {
	//~ case S1_IOCTL_ENABLE_S1:
	//~ {
		//~ LCDoff_ready(1);
		//~ LCDoff_count--;
		//~ break;
	//~ }
	//~ case S1_IOCTL_DISENABLE_S1:
	//~ {
		//~ LCDoff_ready(0);
		//~ LCDoff_count++;
		//~ break;
	//~ }
	//~ default:
		//~ ret = -ENOIOCTLCMD;
		//~ break;
  //~ }
	//~ return 0;
//~ }

static struct file_operations S1_fops = {
	owner:	THIS_MODULE,
	open:	S1_open,
	//~ read:	S1_read,
	//~ write:	S1_write,
	//~ ioctl:	S1_ioctl,
	release:S1_close,
};


static int __init S1_init(void)
{
  int ret;
  if(S1_major)
  {
  		S1_devno = MKDEV(S1_major,S1_minor);
  		ret = register_chrdev_region(S1_devno,1,S1_name);
  }
  else
  {
  		ret = alloc_chrdev_region(&S1_devno,S1_minor,1,S1_name);
  		S1_major = MAJOR(S1_devno);
  }
  S1_cdev = cdev_alloc();
  S1_cdev->owner = THIS_MODULE;
  S1_cdev->ops = &S1_fops;
  cdev_init(S1_cdev,&S1_fops);
  ret = cdev_add(S1_cdev,S1_devno,1);
  
  return 0;
}

static void S1_exit(void)
{
	unregister_chrdev_region(S1_devno, 1);
	cdev_del(S1_cdev);
}

module_init(S1_init);
module_exit(S1_exit);

MODULE_DESCRIPTION("S1 disable");
MODULE_LICENSE("GPL");
