#include <linux/module.h>
#include <linux/cdev.h>
#include <linux/kernel.h>
#include <linux/module.h>
#include <linux/init.h>
#include <linux/sched.h>
#include <linux/fs.h>
#include <linux/fcntl.h>
#include <linux/errno.h>

#include <asm/arch/pxa3xx_gpio.h>
#include <asm/arch/zylonite.h>
#include <asm/uaccess.h>

/* Use 'J' as magic number */
#define S2_IOC_MAGIC  'J'
#define	S2_IOCTL_ENABLE_S2	_IOR(S2_IOC_MAGIC, 2, int)
#define	S2_IOCTL_DISENABLE_S2	_IOR(S2_IOC_MAGIC, 3, int)

extern void devices_ready(int ready);

int S2_major = 0;
int S2_minor = 0;
struct cdev *S2_cdev;
int S2_devno;
static const char S2_name[] = "S2_Disable";
//int LCDoff_count = 0;

int S2_open(struct inode *inode, struct file *filep)
{
	devices_ready(0);
	return 0;
}
int S2_close(struct inode *inode, struct file *filep)
{
	devices_ready(1);
	return 0;
}
//~ ssize_t S2_read(struct file *filep, char *buf, size_t count,loff_t *f_pos)
//~ {
	//~ //printk("************S2 read************\n");
	//~ return 0;
//~ }
//~ ssize_t S2_write(struct file *filep, const char *buf, size_t count,loff_t *f_pos)
//~ {
	//~ //printk("************S2 write************\n");
	//~ return 0;
//~ }
//~ int S2_ioctl(struct inode *inode, struct file *file, unsigned int cmd,unsigned long arg)
//~ {
	//~ int ret;
	//~ switch (cmd) {
	//~ case S2_IOCTL_ENABLE_S2:
	//~ {
		//~ LCDoff_ready(1);
		//~ LCDoff_count--;
		//~ break;
	//~ }
	//~ case S2_IOCTL_DISENABLE_S2:
	//~ {
		//~ LCDoff_ready(0);
		//~ LCDoff_count++;
		//~ break;
	//~ }
	//~ default:
		//~ ret = -ENOIOCTLCMD;
		//~ break;
  //~ }
	//~ return 0;
//~ }

static struct file_operations S2_fops = {
	owner:	THIS_MODULE,
	open:	S2_open,
	//~ read:	S2_read,
	//~ write:	S2_write,
	//~ ioctl:	S2_ioctl,
	release:S2_close,
};


static int __init S2_init(void)
{
  int ret;
  if(S2_major)
  {
  		S2_devno = MKDEV(S2_major,S2_minor);
  		ret = register_chrdev_region(S2_devno,1,S2_name);
  }
  else
  {
  		ret = alloc_chrdev_region(&S2_devno,S2_minor,1,S2_name);
  		S2_major = MAJOR(S2_devno);
  }
  S2_cdev = cdev_alloc();
  S2_cdev->owner = THIS_MODULE;
  S2_cdev->ops = &S2_fops;
  cdev_init(S2_cdev,&S2_fops);
  ret = cdev_add(S2_cdev,S2_devno,1);
  
  return 0;
}

static void S2_exit(void)
{
	unregister_chrdev_region(S2_devno, 1);
	cdev_del(S2_cdev);
}

module_init(S2_init);
module_exit(S2_exit);

MODULE_DESCRIPTION("S2 disable");
MODULE_LICENSE("GPL");
