#include <linux/module.h>
#include <linux/cdev.h>
#include <linux/kernel.h>
#include <linux/module.h>
#include <linux/init.h>
#include <linux/sched.h>
#include <linux/fs.h>
#include <linux/fcntl.h>
#include <linux/errno.h>

#include <asm/arch/pxa3xx_gpio.h>
#include <asm/arch/zylonite.h>
#include <asm/uaccess.h>
#include "battery.h"

#include <linux/irq.h>
#include <linux/interrupt.h>
#include <asm/arch/gpio.h>
#include <asm/arch/ipmc.h>

#include <linux/netlink.h>
#include <linux/sched.h>
#include <net/sock.h>
#include <linux/proc_fs.h>
#include <asm/io.h>

#include <linux/msgevent.h>

int battery_major = 0;
int battery_minor = 0;
struct cdev *battery_cdev;
int devno;

static struct device *dev;
static struct class *battery_class;
static const char battery_name[] = "battery";

int battery_open(struct inode *inode, struct file *filep)
{
	int ret;
	return 0;
}
int battery_close(struct inode *inode, struct file *filep)
{
	int ret;
	return 0;
}
ssize_t battery_read(struct file *filep, char *buf, size_t count,loff_t *f_pos)
{
	int ret;
	return 0;
}
ssize_t battery_write(struct file *filep, const char *buf, size_t count,loff_t *f_pos)
{
	return 0;
}
int battery_voltage = 0;
int get_battery_power()
{
	if((pxa3xx_gpio_get_level(MFP_BAT_CHG_CHGING)==0)&&(pxa3xx_gpio_get_level(MFP_BAT_CHG_PG)==1))
		battery_voltage = 100;
	else if(pxa3xx_gpio_get_level(MFP_BAT_VTH1)==1)
		battery_voltage = 75;
	else if(pxa3xx_gpio_get_level(MFP_BAT_VTH2)==1)
		battery_voltage = 50;
	else if(pxa3xx_gpio_get_level(MFP_BAT_VTH3)==1)
		battery_voltage = 25;
	else if(pxa3xx_gpio_get_level(MFP_BAT_VTH4)==1)
		battery_voltage = 10;
	else 
		battery_voltage = 0;
	return battery_voltage;
}
EXPORT_SYMBOL(get_battery_power);
int battery_ioctl(struct inode *inode, struct file *file, unsigned int cmd,unsigned long arg)
{
	int ret;
	switch (cmd) {
	case BAT_IOCTL_GET_EXT_POWER:
	{
		int external_power;
		external_power = pxa3xx_gpio_get_level(MFP_BAT_CHG_PG);
		
		if (copy_to_user((unsigned long *)arg, &external_power, sizeof(external_power)))
		{
			ret = -EFAULT;
			break;
		}
		break;
	}
	case BAT_IOCTL_GET_CHG_BAT:
	{
		int battery_charging;
		battery_charging = pxa3xx_gpio_get_level(MFP_BAT_CHG_CHGING);
		
		if (copy_to_user((unsigned long *)arg, &battery_charging, sizeof(battery_charging)))
		{
			ret = -EFAULT;
			break;
		}
		break;
	}
	case BAT_IOCTL_GET_BAT_POWER:
	{
		int battery_power;
		battery_power = get_battery_power();
		
		if (copy_to_user((unsigned long *)arg, &battery_power, sizeof(battery_power)))
		{
			ret = -EFAULT;
			break;
		}
		break;
	}
	default:
		ret = -ENOIOCTLCMD;
		break;
  }
	return 0;
}

static struct file_operations battery_fops = {
	owner:	THIS_MODULE,
	open:	battery_open,
	read:	battery_read,
	write:	battery_write,
	ioctl:	battery_ioctl,
	release:battery_close,
};

  static irqreturn_t ext_power_isr(int irq, void *dev_id)
{
	struct MSG_DATA power_msg;
	power_msg.msgID = PowerMessage;
	
	if((irq == gpio_to_irq(MFP2GPIO(MFP_BAT_CHG_CHGING)))&&pxa3xx_gpio_get_level(MFP_BAT_CHG_PG)&&(!pxa3xx_gpio_get_level(MFP_BAT_CHG_CHGING)))
	{
		power_msg.data.powerstate.ischarging = 0;
		power_msg.data.powerstate.battery_power = 100;
		msgevent_report_broadcast(&power_msg);
	}
	else if(irq == gpio_to_irq(MFP2GPIO(MFP_BAT_VTH1)))
	{
		if(pxa3xx_gpio_get_level(MFP_BAT_CHG_CHGING))
		{
			power_msg.data.powerstate.ischarging = 1;
			power_msg.data.powerstate.battery_power = 75;
		}
		else
		{
			power_msg.data.powerstate.ischarging = 0;
			power_msg.data.powerstate.battery_power = 75;
		}
		msgevent_report_broadcast(&power_msg);
	}
	else if(irq == gpio_to_irq(MFP2GPIO(MFP_BAT_VTH2)))
	{
		if(pxa3xx_gpio_get_level(MFP_BAT_CHG_CHGING))
		{
			power_msg.data.powerstate.ischarging = 1;
			power_msg.data.powerstate.battery_power = 50;
		}
		else
		{
			power_msg.data.powerstate.ischarging = 0;
			power_msg.data.powerstate.battery_power = 50;
		}
		msgevent_report_broadcast(&power_msg);
	}
	else if(irq == gpio_to_irq(MFP2GPIO(MFP_BAT_VTH3)))
	{
		if(pxa3xx_gpio_get_level(MFP_BAT_CHG_CHGING))
		{
			power_msg.data.powerstate.ischarging = 1;
			power_msg.data.powerstate.battery_power = 25;
		}
		else
		{
			power_msg.data.powerstate.ischarging = 0;
			power_msg.data.powerstate.battery_power = 25;
		}
		msgevent_report_broadcast(&power_msg);
	}
	else if(irq == gpio_to_irq(MFP2GPIO(MFP_BAT_VTH4)))
	{
		if(pxa3xx_gpio_get_level(MFP_BAT_CHG_CHGING))
		{
			power_msg.data.powerstate.ischarging = 1;
			power_msg.data.powerstate.battery_power = 10;
		}
		else
		{
			power_msg.data.powerstate.ischarging = 0;
			power_msg.data.powerstate.battery_power = 10;
		}
		msgevent_report_broadcast(&power_msg);
	}
		
	return IRQ_HANDLED;
}  
int irq_CHGING,irq_VTH1,irq_VTH2,irq_VTH3,irq_VTH4;
static int __init battery_init(void)
{
  int ret;
  battery_class = class_create(THIS_MODULE, battery_name);
  if(battery_major)
  {
  		devno = MKDEV(battery_major,battery_minor);
  		ret = register_chrdev_region(devno,1,battery_name);
  }
  else
  {
  		ret = alloc_chrdev_region(&devno,battery_minor,1,battery_name);
  		battery_major = MAJOR(devno);
  }
  battery_cdev = cdev_alloc();
  battery_cdev->owner = THIS_MODULE;
  battery_cdev->ops = &battery_fops;
  cdev_init(battery_cdev,&battery_fops);
  ret = cdev_add(battery_cdev,devno,1);
  dev=device_create(battery_class, NULL, devno, battery_name);
  
  irq_CHGING = request_power_gpio_irq(MFP2GPIO(MFP_BAT_CHG_CHGING));
  irq_VTH1 = request_power_gpio_irq(MFP2GPIO(MFP_BAT_VTH1));
  irq_VTH2 = request_power_gpio_irq(MFP2GPIO(MFP_BAT_VTH2));
  irq_VTH3 = request_power_gpio_irq(MFP2GPIO(MFP_BAT_VTH3));
  irq_VTH4 = request_power_gpio_irq(MFP2GPIO(MFP_BAT_VTH4));
  
  return 0;
}

int request_power_gpio_irq(int gpio)
{
	int irq;
	irq = gpio_to_irq(gpio);
	set_irq_type(irq, IRQ_TYPE_EDGE_BOTH);            
	int error = request_irq(irq, ext_power_isr, IRQF_SAMPLE_RANDOM, "power isr",NULL);
	if (error) 
	{
	   //printk("request gpio%d irq fail\n",gpio);
	   return -1;
	}
	return irq;
}
static void battery_exit(void)
{
	free_irq(irq_CHGING,ext_power_isr);
	free_irq(irq_VTH1,ext_power_isr);
	free_irq(irq_VTH2,ext_power_isr);
	free_irq(irq_VTH3,ext_power_isr);
	free_irq(irq_VTH4,ext_power_isr);
	device_destroy(battery_class, devno);
	unregister_chrdev_region(devno, 1);
	class_destroy(battery_class);
	cdev_del(battery_cdev);
}
module_init(battery_init);
module_exit(battery_exit);

MODULE_DESCRIPTION("Current battery capacity");
MODULE_LICENSE("GPL");
