#ifndef __CONFIG_COMPAT_H__
#define __CONFIG_COMPAT_H__

#include <linux/version.h>

#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,33)
#include <generated/autoconf.h>
#else
#include <linux/autoconf.h>
#endif

#undef CONFIG_V4L_USB_DRIVERS
#undef CONFIG_V4L_USB_DRIVERS_MODULE
#define CONFIG_V4L_USB_DRIVERS 1
#undef CONFIG_VIDEO_ALLOW_V4L1
#undef CONFIG_VIDEO_ALLOW_V4L1_MODULE
#undef CONFIG_VIDEO_CAPTURE_DRIVERS
#undef CONFIG_VIDEO_CAPTURE_DRIVERS_MODULE
#define CONFIG_VIDEO_CAPTURE_DRIVERS 1
#undef CONFIG_VIDEO_KERNEL_VERSION
#undef CONFIG_VIDEO_KERNEL_VERSION_MODULE
#undef CONFIG_VIDEO_V4L1_COMPAT
#undef CONFIG_VIDEO_V4L1_COMPAT_MODULE
#define CONFIG_VIDEO_V4L1_COMPAT 1
#undef CONFIG_VIDEO_V4L2
#undef CONFIG_VIDEO_V4L2_MODULE
#define CONFIG_VIDEO_V4L2_MODULE 1
#undef CONFIG_USB_VIDEO_CLASS
#undef CONFIG_USB_VIDEO_CLASS_MODULE
#define CONFIG_USB_VIDEO_CLASS_MODULE 1
#undef CONFIG_VIDEO_V4L2_COMMON
#undef CONFIG_VIDEO_V4L2_COMMON_MODULE
#define CONFIG_VIDEO_V4L2_COMMON_MODULE 1
#undef CONFIG_VIDEO_V4L1
#undef CONFIG_VIDEO_V4L1_MODULE
#undef CONFIG_VIDEO_DEV
#undef CONFIG_VIDEO_DEV_MODULE
#define CONFIG_VIDEO_DEV_MODULE 1
#undef CONFIG_USB_VIDEO_CLASS_INPUT_EVDEV
#undef CONFIG_USB_VIDEO_CLASS_INPUT_EVDEV_MODULE
#define CONFIG_USB_VIDEO_CLASS_INPUT_EVDEV 1
#undef CONFIG_MEDIA_SUPPORT
#undef CONFIG_MEDIA_SUPPORT_MODULE
#define CONFIG_MEDIA_SUPPORT_MODULE 1

#define NEED_SOUND_DRIVER_H 1

#define COMPAT_SND_CTL_BOOLEAN_MONO 1

#define COMPAT_PCM_TO_RATE_BIT 1

#define NEED_IS_SINGULAR 1

#define NEED_CLAMP 1

#define NEED_PROC_CREATE 1

#define NEED_ALGO_CONTROL 1

#define NEED_USB_ENDPOINT_TYPE 1

#define NEED_PCI_IOREMAP_BAR 1

#define NEED_SND_CARD_CREATE

#define NEED_POLL_SCHEDULE 1

#define NEED_SND_BUG_ON 1

#define NEED_BITOPS 1

#endif
