/*
   Copyright (C) 2005, Intel Corporation.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


 *(C) Copyright 2006 Marvell International Ltd.
 * All Rights Reserved
 */

/*****************************************************************************
 * Abstract:
 * 	contains all OV2655 function prototypes.
 * 	Declares no storage.
 *
 * Notes:Only valid for processor code named Monahans.
 *****************************************************************************/
 
#ifndef __CAM_OV2655_HEADER__
#define __CAM_OV2655_HEADER__

#include "camera.h"

/******************************************************************************
 *	Prototypes
 ******************************************************************************/
int ov2655_init( p_camera_context_t );

int ov2655_deinit( p_camera_context_t );

int ov2655_sleep(  p_camera_context_t camera_context );

int ov2655_wake(  p_camera_context_t camera_context );

int ov2655_set_capture_format( p_camera_context_t );

int ov2655_start_capture( p_camera_context_t, unsigned int frames );

int ov2655_stop_capture( p_camera_context_t );

int ov2655_read_16bit(  p_camera_context_t camera_context,
		u16 reg_addr,  u16 *reg_val);

int ov2655_write_16bit(  p_camera_context_t camera_context,
		u16 reg_addr,  u16 reg_val);

int ov2655_set_power_mode(p_camera_context_t camera_context, u8 mode);

int ov2655_set_contrast( p_camera_context_t camera_context,
		u8 mode, u32 value);

int ov2655_set_exposure( p_camera_context_t camera_context,
		u8 mode, u32 value);

int ov2655_set_white_balance( p_camera_context_t camera_context,
		u8 mode, u32 value);
		
int ov2655_set_zoom(p_camera_context_t camera_context,u32 value);

int ov2655_set_banding(p_camera_context_t camera_context,u32 value);

int ov2655_set_sharpness(p_camera_context_t camera_context,u32 value);

int ov2655_set_scene(p_camera_context_t camera_context,u32 value);
#endif
