
#define BQ27541_ADDRESS 0x55

#define BQ27541_COMMAND_CNTL 	0x00
#define BQ27541_COMMAND_AR 		0x02
#define BQ27541_COMMAND_ARTTE 	0x04
#define BQ27541_COMMAND_TEMP 	0x06
#define BQ27541_COMMAND_VOLT 	0x08
#define BQ27541_COMMAND_FLAGS 	0x0a
#define BQ27541_COMMAND_NAC 	0x0c
#define BQ27541_COMMAND_FAC 	0x0e
#define BQ27541_COMMAND_RM 		0x10
#define BQ27541_COMMAND_FCC 	0x12
#define BQ27541_COMMAND_AI 		0x14
#define BQ27541_COMMAND_TTE 	0x16
#define BQ27541_COMMAND_TTF 	0x18
#define BQ27541_COMMAND_SI 		0x1a
#define BQ27541_COMMAND_STTE 	0x1c
#define BQ27541_COMMAND_MLI 	0x1e
#define BQ27541_COMMAND_MLTTE 	0x20
#define BQ27541_COMMAND_AE 		0x22
#define BQ27541_COMMAND_AP 		0x24
#define BQ27541_COMMAND_TTECP 	0x26
#define BQ27541_COMMAND_RSVD 	0x28
#define BQ27541_COMMAND_CC 		0x2a
#define BQ27541_COMMAND_SOC 	0x2c
#define BQ27541_COMMAND_DCAP 	0x3c

#define BQ27541_COMMAND_DFCLS 	0x3e
#define BQ27541_COMMAND_DFBLK 	0x3f
#define BQ27541_COMMAND_DF 		0x40
#define BQ27541_COMMAND_DFDCKS 	0x60
#define BQ27541_COMMAND_DFDCNTL 	0x61
#define BQ27541_COMMAND_DNAMELEN 	0x62
#define BQ27541_COMMAND_DNAME 	0x63


#define BQ27541_CNTL_CONTROL_STATUS 	0x0000
#define BQ27541_CNTL_DEVICE_TYPE 		0x0001
#define BQ27541_CNTL_FW_VERSION 		0x0002
#define BQ27541_CNTL_HW_VERSION 		0x0003
#define BQ27541_CNTL_DF_CHECKSUM 		0x0004
#define BQ27541_CNTL_RESET_DATA 		0x0005
#define BQ27541_CNTL_RESERVED 			0x0006
#define BQ27541_CNTL_PREV_MACWRITE 		0x0007
#define BQ27541_CNTL_CHEM_ID 			0x0008
#define BQ27541_CNTL_SET_FULLSLEEP 		0x0010
#define BQ27541_CNTL_SET_HIBERNATE 		0x0011
#define BQ27541_CNTL_CLEAR_HIBERNATE 	0x0012
#define BQ27541_CNTL_SET_SHUTDOWN 		0x0013
#define BQ27541_CNTL_CLEAR_SHUTDOWN 	0x0014
#define BQ27541_CNTL_SEALED 			0x0020
#define BQ27541_CNTL_IT_ENABLE 			0x0021
#define BQ27541_CNTL_CAL_MODE 			0x0040
#define BQ27541_CNTL_RESET 				0x0041


/* Use 'I' as magic number */
#define BQ27541_IOC_MAGIC  'I'
#define	BQ27541_IOCTL_GET_ARTTE		_IOR(BQ27541_IOC_MAGIC, 2, int)
#define	BQ27541_IOCTL_GET_TEMP		_IOR(BQ27541_IOC_MAGIC, 3, int)
#define	BQ27541_IOCTL_GET_VOLT		_IOR(BQ27541_IOC_MAGIC, 4, int)
#define	BQ27541_IOCTL_GET_FLAGS		_IOR(BQ27541_IOC_MAGIC, 5, int)
#define	BQ27541_IOCTL_GET_NAC		_IOR(BQ27541_IOC_MAGIC, 6, int)
#define	BQ27541_IOCTL_GET_FAC		_IOR(BQ27541_IOC_MAGIC, 7, int)
#define	BQ27541_IOCTL_GET_RM		_IOR(BQ27541_IOC_MAGIC, 8, int)
#define	BQ27541_IOCTL_GET_FCC		_IOR(BQ27541_IOC_MAGIC, 9, int)
#define	BQ27541_IOCTL_GET_AI		_IOR(BQ27541_IOC_MAGIC, 10, int)
#define	BQ27541_IOCTL_GET_TTE		_IOR(BQ27541_IOC_MAGIC, 11, int)
#define	BQ27541_IOCTL_GET_TTF		_IOR(BQ27541_IOC_MAGIC, 12, int)
#define	BQ27541_IOCTL_GET_SI		_IOR(BQ27541_IOC_MAGIC, 13, int)
#define	BQ27541_IOCTL_GET_STTE		_IOR(BQ27541_IOC_MAGIC, 14, int)
#define	BQ27541_IOCTL_GET_MLI		_IOR(BQ27541_IOC_MAGIC, 15, int)
#define	BQ27541_IOCTL_GET_MLTTE		_IOR(BQ27541_IOC_MAGIC, 16, int)
#define	BQ27541_IOCTL_GET_AE		_IOR(BQ27541_IOC_MAGIC, 17, int)
#define	BQ27541_IOCTL_GET_AP		_IOR(BQ27541_IOC_MAGIC, 18, int)
#define	BQ27541_IOCTL_GET_TTECP		_IOR(BQ27541_IOC_MAGIC, 19, int)
#define	BQ27541_IOCTL_GET_RSVD		_IOR(BQ27541_IOC_MAGIC, 20, int)
#define	BQ27541_IOCTL_GET_CC		_IOR(BQ27541_IOC_MAGIC, 21, int)
#define	BQ27541_IOCTL_GET_SOC		_IOR(BQ27541_IOC_MAGIC, 22, int)
#define	BQ27541_IOCTL_GET_DCAP		_IOR(BQ27541_IOC_MAGIC, 23, int)
#define	BQ27541_IOCTL_GET_CHG_BAT		_IOR(BQ27541_IOC_MAGIC, 24, int)














