#ifndef _ETABLE_MSGEVENT_HEADER_
#define _ETABLE_MSGEVENT_HEADER_

#define _USE_NETLINK_
//#define _USE_FILE_NOTE_

#ifdef _USE_FILE_NOTE_
#include <linux/list.h>
#include <linux/wait.h>
#endif

typedef enum {
	PowerMessage=0,
	AudioMessage=1,
	UsbMessage=2,
	SDMessage=3,
	WifiMessage=4,
	SensorBoardDataMessage=5,
	sensorboradLockMessage=6,
	SensorBoardSwitchMessage=7,
	PowerModeMessage=8,
} MESSAGE_ID_TYPE;


struct MSG_DATA
{
	//0: battery power, 1: audio, 2: usb, 3: sd, 4: wift, 5: sensorboard data, 6: sensorboard lock, 
	//7: sensorboard switch 8: power mode state
	int msgID;
	
	union{	
		int jackstate; //for audio. 1: insert, 0: unplug
		int usbcabstate; //for usb. 1: insert, 0: unplug
		
		int senvalue; //for sensorborad. 7bit data
		int senlock;  //for sensorborad. 1: disable, 0: enable
		int senswitchstate; //for sensorboard. 1: has pressed switch
		
		int sdstate; //for sd. 1: insert, 0: unplug
		
		int wifistate;
		
		int powermodestate; //1: lcdoff, 2:suspend, 3:resume
		
		struct {
			int ischarging; //for power. 1: charging, 0: not charging
			int battery_power; //for power. battery power value
		}powerstate;
		
	}data;
	
#ifdef _USE_FILE_NOTE_
	struct list_head note;
#endif
};

#endif
